
#include <stdio.h>
#include <windows.h>

#include "resource.h"


static BOOL CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp);
static BOOL TargetWindowSet(HWND hWnd);
static void TargetWindowFree(HWND hWnd);
static BOOL SetNewWindowPos(HWND hWnd, BOOL);

HWND GetTargetWindow(void);
void SetTargetWindow(HWND hNewWnd);
HINSTANCE GetInstance(void);
void SetString(HWND hWnd, unsigned int resource, unsigned char *src);
BOOL CALLBACK WindowListWndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp);

static HWND hTargetWnd;
static HINSTANCE hInst;



int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPevInstance, PSTR lpCmdLine, int nCmdShow)
{

	hInst = hInstance;

	DialogBox(hInstance, MAKEINTRESOURCE(main_window), NULL, (DLGPROC) MainWndProc);
	return 0;
}


static BOOL CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	switch (msg) {
	case WM_COMMAND:
		switch (LOWORD(wp)) {
		case IDOK:
			/*
			 * EBhE
			 */

			if (SetNewWindowPos(hWnd, TRUE) == FALSE)
				TargetWindowFree(hWnd);

			break;

		case IDNO:
			if (SetNewWindowPos(hWnd, FALSE) == FALSE)
				TargetWindowFree(hWnd);

			break;

		case ID_TARGET_WINDOW_SET:
			/*
			 * EBhEꗗEBhEI
			 */
			if (DialogBox(GetInstance(), MAKEINTRESOURCE(enum_window), hWnd, (DLGPROC) WindowListWndProc) != IDCANCEL)
				TargetWindowSet(hWnd);

			break;

		case ID_GET_FOREGROUND_WINDOW:
			/*
			 * tHAOhEBhEI
			 */

			MessageBox(hWnd, "ΏۂɂEBhE 5 bȓɃANeBu(őO)ɂĂ\n(^Cgo[Ȃ悤ɂĂ)", TEXT("EBhEݒ"), MB_OK | MB_ICONQUESTION);
			ShowWindow(hWnd, SW_HIDE);
			Sleep(5000);
			SetTargetWindow(GetForegroundWindow());
			ShowWindow(hWnd, SW_SHOW);

			TargetWindowSet(hWnd);
			break;

		default:
			return FALSE;
		}
		break;

	case WM_INITDIALOG:
		SetFocus(hWnd);
		TargetWindowFree(hWnd);
		break;

	case WM_CLOSE:
		EndDialog(hWnd, IDCANCEL);
		break;

	default:
		return FALSE;
	}

	return TRUE;
}



/**
 * ^[QbgEBhEGfBbgɃZbg
 */
static BOOL TargetWindowSet(HWND hWnd)
{
	if (!GetTargetWindow()) {
		MessageBox(hWnd, TEXT("EBhE̎擾Ɏs܂"), NULL, MB_OK | MB_ICONWARNING);
		TargetWindowFree(hWnd);
	} else {
		static unsigned char input_buf[512];

		if (!GetWindowText(GetTargetWindow(), (LPSTR) input_buf, sizeof input_buf)) {
			MessageBox(hWnd, TEXT("EBhE^Cg̎擾Ɏs܂"), NULL, MB_OK | MB_ICONWARNING);
			TargetWindowFree(hWnd);
		} else {
			long int style;

			SetString(hWnd, ID_TARGET_WINDOW_TITLE, input_buf);

			style = GetWindowLong(hWnd, GWL_EXSTYLE);
			EnableWindow(GetDlgItem(hWnd, (style & WS_EX_TOPMOST) ? IDOK : IDNO), FALSE);
			EnableWindow(GetDlgItem(hWnd, (style & WS_EX_TOPMOST) ? IDNO : IDOK), TRUE);

			return TRUE;
		}
	}

	return FALSE;
}


/**
 * GfBbg̃^[QbgEBhE
 */
static void TargetWindowFree(HWND hWnd)
{
	SetTargetWindow(NULL);
	SetString(hWnd, ID_TARGET_WINDOW_TITLE, NULL);
	return;
}


static BOOL SetNewWindowPos(HWND hWnd, BOOL flg)
{
	if (!GetTargetWindow())
		MessageBox(hWnd, "Ώۂ̃EBhEݒ肳Ă܂", NULL, MB_OK | MB_ICONWARNING);
	else {
		if (!SetWindowPos(GetTargetWindow(), (flg) ? HWND_TOPMOST : HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW))
				MessageBox(hWnd, TEXT("ύXɎs܂"), NULL, MB_YESNO | MB_ICONWARNING);
		else {
			EnableWindow(GetDlgItem(hWnd, (flg) ? IDOK : IDNO), FALSE);
			EnableWindow(GetDlgItem(hWnd, (flg) ? IDNO : IDOK), TRUE);

			return TRUE;
		}
	}

	return FALSE;
}


HWND GetTargetWindow()
{
	return hTargetWnd;
}


void SetTargetWindow(HWND hNewWnd)
{
	hTargetWnd = hNewWnd;
	return;
}


HINSTANCE GetInstance()
{
	return hInst;
}


void SetString(HWND hWnd, unsigned int resource, unsigned char *src)
{
	SendDlgItemMessage(hWnd, resource, WM_SETTEXT, 0, src ? (LPARAM) src : (LPARAM) "");
	return;
}


