#include <stdio.h>
#include <windows.h>

#include "resource.h"


static BOOL CALLBACK EnumWindowsProc(HWND hwnd , LPARAM lp);
static void list_remove(void);

struct listEnumWindow
{
	HWND hWnd;
	struct listEnumWindow *next;
};

static struct listEnumWindow *start, *end;



BOOL CALLBACK WindowListWndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	static HWND hList;

	switch (msg) {
	case WM_COMMAND:
		switch (HIWORD(wp)) {
		case LBN_DBLCLK:
			/*
			 * _uNbN "ݒ" {^Ɠl̓
			 */
			SendMessage(hWnd, WM_COMMAND, (WPARAM) MAKELONG(IDOK, 0), 0);
		//	goto done;
			break;
		}

		switch (LOWORD(wp)) {
		case IDOK:
	//	done:
			{
				/*
				 * IĂEBhE擾
				 */
				int index, i;
				struct listEnumWindow *pos;
	
				index = SendMessage(hList, LB_GETCURSEL, 0, 0);

				if (index == LB_ERR) {
					MessageBox(hWnd, "EBhEIĂ", "G[", MB_OK | MB_ICONWARNING);
					break;
				}


				/*
				 * EBhEXgΏۂ̃EBhEnh擾
				 */
				pos = start;

				for (i = 0; pos; i++) {
					if (i == index) {
						SetTargetWindow(pos -> hWnd);
						break;
					}

					pos = pos -> next;
				}
			}

			EndDialog(hWnd, IDOK);
			break;

		case IDCANCEL:
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;

		case ID_REMAKE:
			list_remove();
			SendMessage(hList , LB_RESETCONTENT , 0 , 0);
			EnumWindows(EnumWindowsProc , (LPARAM) hList);
			break;

		default:
			return FALSE;
		}
		break;

	case WM_INITDIALOG:
		SetFocus(hWnd);
		hList = GetDlgItem(hWnd, ID_WINDOW_LIST);
		EnumWindows(EnumWindowsProc , (LPARAM) hList);
		break;

	case WM_DESTROY:
		list_remove();
		break;

	case WM_CLOSE:
		EndDialog(hWnd, IDCANCEL);
		break;

	default:
		return FALSE;
	}

	return TRUE;
}


static BOOL CALLBACK EnumWindowsProc(HWND hwnd , LPARAM lp)
{
	static TCHAR strWindowText[256];

	GetWindowText(hwnd, strWindowText, sizeof strWindowText);

	if (strWindowText[0] != '\0') {
		{
			long int style;

			style = GetWindowLong(hwnd, GWL_STYLE);
			if (!(style & WS_VISIBLE))
				return TRUE;

		}


		/*
		 * ̃EBhE͏O
		 */

		if (!strcmp(strWindowText, WINDOWLIST_TITLE))
			return TRUE;

		SendMessage((HWND) lp, LB_ADDSTRING, 0, (long) strWindowText);

		{
			/*
			 * Xgɒǉ
			 */

			struct listEnumWindow *new;

			new = malloc(sizeof (struct listEnumWindow));

			if (!new)
				return FALSE;
			else {
				new -> hWnd = hwnd;
				new -> next = NULL;

				if (!start)
					start = new;

				if (!end)
					end = new;
				else {
					end -> next = new;
					end = new;
				}

			}
		}
	}

	return TRUE;
}

/**
 * EBhEXg
 */
static void list_remove()
{
	struct listEnumWindow *pos;

	while (start) {
		pos = start -> next;
		free(start);
		start = pos;
	}

	end = NULL;

	return;
}

